<template>
<div class="centred">
	<div class="inside">
		<component
			v-for="item in items"
			v-on:change="onChange"
			v-on:click="onItemClicked"
			v-on:hover="setSelected"
			:id="item.id"
			:is="item.type"
			:key="item.id"
			:options="item.options"
			:ref="item.ref"
			:selected="item.id === selected"
			:value="item.value"
		>{{ item.text }}</component>
	</div>
</div>
</template>

<script>
// Components
import DropdownItem from "../components/DropdownItem.vue"
import InputItem from "../components/InputItem.vue"
import StandardItem from "../components/StandardItem.vue"

// Constants
import { SUPPORTED_LANGUAGES } from "../../managers/LanguageManager.js"

export default {
	components: { DropdownItem, InputItem, StandardItem },
	created () {
		UI.on("PRESS_UP", () => {
			if (this.mounted) this.pressUp()
		})
		UI.on("PRESS_DOWN", () => {
			if (this.mounted) this.pressDown()
		})
		UI.on("PRESS_ENTER", () => {
			if (this.mounted) this.onClick(this.selected)
		})
		UI.on("PRESS_BACK", () => {
			if (this.mounted) this.onBack()
		})
		UI.on("CHANGE_LANGUAGE", () => {
			this.onLanguageChange()
		})
	},
	data () {
		return {
			items: this.generateItems(),
			mounted: false,
			selected: 0
		}
	},
	destroyed () {
		this.mounted = false
	},
	methods: {
		generateItems: function () {
			let items = [{
				id: 0,
				ref: "r0",
				text: "Name",
				type: "input-item",
				value: Settings.get("NAME") || ""
			}, {
				id: 1,
				options: SUPPORTED_LANGUAGES.map((lang) => {
					return Language.getIn("LANGUAGE_NAME", lang)
				}),
				ref: "r1",
				text: "Language",
				type: "dropdown-item",
				value: Language.get("LANGUAGE_NAME")
			}, {
				id: 2,
				ref: "r2",
				text: "Confirm",
				type: "standard-item"
			}]

			return items
		},
		getSelected: function () {
			return this.$refs[this.items[this.selected].ref][0]
		},
		onBack: function () {
			const item = this.getSelected()

			if (item.focused) {
				item.blur()
			}
		},
		onChange: function (id, value) {
			switch (id) {
				case 0:
					Settings.set("NAME", value)
					break
				case 1:
					Settings.set("LANGUAGE", SUPPORTED_LANGUAGES[value])
					break
				case 2:
					debugger
					break
			}
			this.items = this.generateItems()
		},
		onClick: function (id) {
			const item = this.$refs[this.items[id].ref][0]
			UI.emit("PLAY_CLICK_SOUND")
			if (!item.focused) {
				item.onClick()
			} else {
				item.$emit("PRESS_ENTER")
			}
		},
		onItemClicked: function (id) {
			UI.emit("PLAY_CLICK_SOUND")
			UI.emit("SELECT_FIRST_SETUP", id)
			this.items = this.generateItems()
		},
		onLanguageChange: function () {
			this.items[0].text = Language.get("LANGUAGE")
			// this.items[1].text = Language.get("LOCAL")
			this.items[1].text = Language.get("LANGUAGE_NAME")
			// this.items[3].text = Language.get("QUIT")
		},
		pressDown: function () {
			const item = this.getSelected()

			if (item.focused) {
				item.$emit("PRESS_DOWN")
			} else {
				this.setSelected(Math.min(this.items.length - 1, this.selected + 1))
			}
		},
		pressUp: function () {
			const item = this.getSelected()

			if (item.focused) {
				item.$emit("PRESS_UP")
			} else {
				this.setSelected(Math.max(0, this.selected - 1))
			}
		},
		setSelected: function (id) {
			if (this.selected !== id) {
				UI.emit("PLAY_HOVER_SOUND")
			}
			this.selected = id
		}
	},
	mounted () {
		this.mounted = true
	},
	name: "first-setup"
}
</script>

<style lang="less" scoped>
@import "./styles/Centred.less";

.centred {
	background-image: url("../../../assets/gui/bg/press_start.jpg");
	background-size: cover;
	font-size: 1em;
}

.inside {
	width: 80em;
}
</style>